import java.io.*;

class PipesShow {
  
  PipedWriter authorWrites = new PipedWriter(); // potok, do ktrego pisze autor 
  PipedReader duplicatorReads;                  // potok, z ktorego czyta duplikator
  
  Duplicator dup;                                
  
  PipesShow(int numLines, int numWriters) {
    
    // kady przepisywacz na swoj przestrze pisania
    SpaceToWrite[] writeSpace = new SpaceToWrite[numWriters];
    for (int i=0; i < writeSpace.length; i++) 
      writeSpace[i] = new SpaceToWrite(20, 30); // 20 wierszy, 30 kolumn
    
    try {
      // Poczenie potoku do ktorego pisze autor
      // z nowoutworzonym potokiem, z ktrego bdzie czyta duplikator
      duplicatorReads = new PipedReader(authorWrites);
      
      // utworzenie duplikatora (on z kolei stworzy i uruchomi przepisywaczy)
      dup = new Duplicator(duplicatorReads, // skd bdzie czyta
                           writeSpace);     // przetstrze pisania dla przepisywaczy
      
      // start wtku duplikatora
      dup.start();    
      
    } catch (IOException exc) {
        System.out.println("Nie mona stworzy duplikatora");
        exc.printStackTrace();
        System.exit(1);
    }
    
    SpaceToWrite.show(numWriters); // pokazanie oglnej przestrzeni pisania
                                   // grupujcej przestrzenie pisania 
                                   // kadego przepisywacza 

    // Teraz autor bdzie pisa!
    // Utworzenie obiektu klasy Autor powoduje rozpoczcie przez niego pisania
    
    String words[] = { "Ala", "ma", "kota", "i", "psa" };
    
    Author autor = new Author(numLines,      // ile wierszy ma napisa
                              words,         // z jakich sw skada teksty
                              authorWrites); // Dokd je zapisywa 
  }

  public static void main(String args[]) { 
    int numLin = 0; // ile wierszy ma napisa autor
    int numWri = 0; // ilu jest przepisywaczy
    try {
      numLin = Integer.parseInt(args[0]);
      numWri = Integer.parseInt(args[1]);
    } catch(Exception exc) {
        System.out.println("Syntax: java  PipesShow numLines numWri");
        System.exit(1);
    }    
    new PipesShow(numLin, numWri);  
  }
}
